QGIS silently fails to draw Oracle features with a curve in it

2017-07-07 03:18 PM - Richard Duivenvoorde

Status: Closed

Priority: Normal

Assignee:

Category: Data Provider/Oracle

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 24708

Description

We have some data in a (bigggg) Oracle database which are actually being digitized using Microstation tools.

Looking into the table with QGIS, there are no errors or warnings, 

but ALL features containing arcs/curves are silently ignored / not shown.

See screendump:

- in green you see the features if they are 'generalized' / decurved by FME showing all features

- in blue you see the original features as loaded as an Oracle layer in QGIS.

The best solution off course would be to let QGIS work with those curves...

But I think at least QGIS should give some warning that it is failing to retrieve/paint(?) some of the features?

Those Features are so called 'compound elements' which are (or can be) a combination of arcs/curves and regular lines.

(see https://docs.oracle.com/cd/A97630_01/appdev.920/a96630/sdo_objrelschema.htm and search for 1005 and SDO_ETYPE)

The big feature in the middle dumped to sql as:

OGC_GEOMETRY

MDSYS.SDO_GEOMETRY(

2003,28992,NULL,MDSYS.SDO_ELEM_INFO_ARRAY(1,1005,3,1,2,2,5,2,2,9,2,1),MDSYS.SDO_ORDINATE_ARRAY(134785.64,4

8701.244,134787.236,448702.265,134787.653,448704.114,134786.664,448705.706,134784.848,448706.172,134784.539,448708.678,134784.519,448711.222,134784.568,448713.025,134784.846,448713.016,134784.976,448715.425,134785.544,44871

8,134784.519,448711.222,134784.568,448713.025,134784.846,448713.016,134784.976,448715.425,134785.544,448719.275,134785.617,448719.747,134786.493,448723.5,134792.56,448743.384,134789.466,448744.318,134788.26,448744.682,134786.526,448743.758,134786.267,448742.926,134784.573,448743.454,134784.845,448744.288,134784.301,448745.301,134784.054,4

5.617,448719.747,134786.493,448723.5,134792.56,448743.384,134789.466,448744.318,134788.26,448744.682,134786.526,448743.758,134786.267,448742.926,134784.573,448743.454,134784.845,448744.288,134784.301,448745.301,134784.054,448745.76,134780.938,448746.724,134778.443,448751.533,134775.846,448752.312,134775.347,448752.481,134773.084,448753.174,134772.895,448753.232,134752.877,448759.361,134750.604,448760.057,134747.614,448760.973,134742.811,448758.39,134742.

.758,134786.267,448742.926,134784.573,448743.454,134784.845,448744.288,134784.301,448745.301,134784.054,448745.76,134780.938,448746.724,134778.443,448751.533,134775.846,448752.312,134775.347,448752.481,134773.084,448753.174,134772.895,448753.232,134752.877,448759.361,134750.604,448760.057,134747.614,448760.973,134742.811,448758.39,134742.699,448758.425,134742.586,448758.46,134740.248,448759.183,134739.681,448759.358,134738.196,448758.55,134738.004,448757.927,134736.381,448758.414,134736.653,448759.295,134735.841,448760.665,134723.198,448764.461,134720.591,448756.009,134

80.938,448746.724,134778.443,448751.533,134775.846,448752.312,134775.347,448752.481,134773.084,448753.174,134772.895,448753.232,134752.877,448759.361,134750.604,448760.057,134747.614,448760.973,134742.811,448758.39,134742.699,448758.425,134742.586,448758.46,134740.248,448759.183,134739.681,448759.358,134738.196,448758.55,134738.004,448757.927,134736.381,448758.414,134736.653,448759.295,134735.841,448760.665,134723.198,448764.461,134720.591,448756.009,134718.381,448748.847,134713.927,448750.184,134712.455,448749.417,134708.101,448735.136,134711.968,448727.797,134710.676,448723.502,134710.595,448723.233,134709.803,448720.6,134707.099,448721.44,134707.034,448721.507,134704.388,448719.238,

48753.232,134752.877,448759.361,134750.604,448760.057,134747.614,448760.973,134742.811,448758.39,134742.699,448758.425,134742.586,448758.46,134740.248,448759.183,134739.681,448759.358,134738.196,448758.55,134738.004,448757.927,134736.381,448758.414,134736.653,448759.295,134735.841,448760.665,134723.198,448764.461,134720.591,448756.009,134718.381,448748.847,134713.927,448750.184,134712.455,448749.417,134708.101,448735.136,134711.968,448727.797,134710.676,448723.502,134710.595,448723.233,134709.803,448720.6,134707.099,448721.44,134707.034,448721.507,134704.388,448719.238,134704.051,448718.877,134700.869,448715.095,134700.748,448714.933,134700.572,448714.7,134698.07,448710.556,134697.928,448710.257,134697.86,448710.112,134696.167,448705.398,134696.056,448704.918,134695.161,448700.086,134695.117,448699.5

5,134742.586,448758.46,134740.248,448759.183,134739.681,448759.358,134738.196,448758.55,134738.004,448757.927,134736.381,448758.414,134736.653,448759.295,134735.841,448760.665,134723.198,448764.461,134720.591,448756.009,134718.381,448748.847,134713.927,448750.184,134712.455,448749.417,134708.101,448735.136,134711.968,448727.797,134710.676,448723.502,134710.595,448723.233,134709.803,448720.6,134707.099,448721.44,134707.034,448721.507,134704.388,448719.238,134704.051,448718.877,134700.869,448715.095,134700.748,448714.933,134700.572,448714.7,134698.07,448710.556,134697.928,448710.257,134697.86,448710.112,134696.167,448705.398,134696.056,448704.918,134695.161,448700.086,134695.117,448699.576,134695.206,448694.765,134695.256,448694.263,134696.092,448689.351,134696.238,448688.867,134698.025,448684.232,134698.231,448683.802,134699.023,448682.417,134696.538,448681.075,134697.913,448678.885,134699.428,448676.8,134700.565,448

81,448758.414,134736.653,448759.295,134735.841,448760.665,134723.198,448764.461,134720.591,448756.009,134718.381,448748.847,134713.927,448750.184,134712.455,448749.417,134708.101,448735.136,134711.968,448727.797,134710.676,448723.502,134710.595,448723.233,134709.803,448720.6,134707.099,448721.44,134707.034,448721.507,134704.388,448719.238,134704.051,448718.877,134700.869,448715.095,134700.748,448714.933,134700.572,448714.7,134698.07,448710.556,134697.928,448710.257,134697.86,448710.112,134696.167,448705.398,134696.056,448704.918,134695.161,448700.086,134695.117,448699.576,134695.206,448694.765,134695.256,448694.263,134696.092,448689.351,134696.238,448688.867,134698.025,448684.232,134698.231,448683.802,134699.023,448682.417,134696.538,448681.075,134697.913,448678.885,134699.428,448676.8,134700.565,448675.391,134700.712,448675.208,134700.765,448675.251,134702.313,448673.698,134703.377,448672.629,134706.297,448670.345,134709.512,448668.514,134709.497,448668.455,134710.251,448668.131,134714.149,448667.027,134714.93,448666.866,134717.1

48.847,134713.927,448750.184,134712.455,448749.417,134708.101,448735.136,134711.968,448727.797,134710.676,448723.502,134710.595,448723.233,134709.803,448720.6,134707.099,448721.44,134707.034,448721.507,134704.388,448719.238,134704.051,448718.877,134700.869,448715.095,134700.748,448714.933,134700.572,448714.7,134698.07,448710.556,134697.928,448710.257,134697.86,448710.112,134696.167,448705.398,134696.056,448704.918,134695.161,448700.086,134695.117,448699.576,134695.206,448694.765,134695.256,448694.263,134696.092,448689.351,134696.238,448688.867,134698.025,448684.232,134698.231,448683.802,134699.023,448682.417,134696.538,448681.075,134697.913,448678.885,134699.428,448676.8,134700.565,448675.391,134700.712,448675.208,134700.765,448675.251,134702.313,448673.698,134703.377,448672.629,134706.297,448670.345,134709.512,448668.514,134709.497,448668.455,134710.251,448668.131,134714.149,448667.027,134714.93,448666.866,134717.197,448666.642,134718.644,448666.499,134720.852,448666.332,134722.505,448666.099,134722.541,448666.37,134723.172,448668.398,134725.377,448667.707,134728.922,448667.322,134731.217,448667.625,134731.535,448665.325,134735.665,448659.473,13

34710.595,448723.233,134709.803,448720.6,134707.099,448721.44,134707.034,448721.507,134704.388,448719.238,134704.051,448718.877,134700.869,448715.095,134700.748,448714.933,134700.572,448714.7,134698.07,448710.556,134697.928,448710.257,134697.86,448710.112,134696.167,448705.398,134696.056,448704.918,134695.161,448700.086,134695.117,448699.576,134695.206,448694.765,134695.256,448694.263,134696.092,448689.351,134696.238,448688.867,134698.025,448684.232,134698.231,448683.802,134699.023,448682.417,134696.538,448681.075,134697.913,448678.885,134699.428,448676.8,134700.565,448675.391,134700.712,448675.208,134700.765,448675.251,134702.313,448673.698,134703.377,448672.629,134706.297,448670.345,134709.512,448668.514,134709.497,448668.455,134710.251,448668.131,134714.149,448667.027,134714.93,448666.866,134717.197,448666.642,134718.644,448666.499,134720.852,448666.332,134722.505,448666.099,134722.541,448666.37,134723.172,448668.398,134725.377,448667.707,134728.922,448667.322,134731.217,448667.625,134731.535,448665.325,134735.665,448659.473,134737.321,448660.608,134787.547,448694.701,134786.952,448696.342,134786.174,448698.759,134785.64,448701.244))

48718.877,134700.869,448715.095,134700.748,448714.933,134700.572,448714.7,134698.07,448710.556,134697.928,448710.257,134697.86,448710.112,134696.167,448705.398,134696.056,448704.918,134695.161,448700.086,134695.117,448699.576,134695.206,448694.765,134695.256,448694.263,134696.092,448689.351,134696.238,448688.867,134698.025,448684.232,134698.231,448683.802,134699.023,448682.417,134696.538,448681.075,134697.913,448678.885,134699.428,448676.8,134700.565,448675.391,134700.712,448675.208,134700.765,448675.251,134702.313,448673.698,134703.377,448672.629,134706.297,448670.345,134709.512,448668.514,134709.497,448668.455,134710.251,448668.131,134714.149,448667.027,134714.93,448666.866,134717.197,448666.642,134718.644,448666.499,134720.852,448666.332,134722.505,448666.099,134722.541,448666.37,134723.172,448668.398,134725.377,448667.707,134728.922,448667.322,134731.217,448667.625,134731.535,448665.325,134735.665,448659.473,134737.321,448660.608,134787.547,448694.701,134786.952,448696.342,134786.174,448698.759,134785.64,448701.244))

34697.86,448710.112,134696.167,448705.398,134696.056,448704.918,134695.161,448700.086,134695.117,448699.576,134695.206,448694.765,134695.256,448694.263,134696.092,448689.351,134696.238,448688.867,134698.025,448684.232,134698.231,448683.802,134699.023,448682.417,134696.538,448681.075,134697.913,448678.885,134699.428,448676.8,134700.565,448675.391,134700.712,448675.208,134700.765,448675.251,134702.313,448673.698,134703.377,448672.629,134706.297,448670.345,134709.512,448668.514,134709.497,448668.455,134710.251,448668.131,134714.149,448667.027,134714.93,448666.866,134717.197,448666.642,134718.644,448666.499,134720.852,448666.332,134722.505,448666.099,134722.541,448666.37,134723.172,448668.398,134725.377,448667.707,134728.922,448667.322,134731.217,448667.625,134731.535,448665.325,134735.665,448659.473,134737.321,448660.608,134787.547,448694.701,134786.952,448696.342,134786.174,448698.759,134785.64,448701.244))

6,448694.765,134695.256,448694.263,134696.092,448689.351,134696.238,448688.867,134698.025,448684.232,134698.231,448683.802,134699.023,448682.417,134696.538,448681.075,134697.913,448678.885,134699.428,448676.8,134700.565,448675.391,134700.712,448675.208,134700.765,448675.251,134702.313,448673.698,134703.377,448672.629,134706.297,448670.345,134709.512,448668.514,134709.497,448668.455,134710.251,448668.131,134714.149,448667.027,134714.93,448666.866,134717.197,448666.642,134718.644,448666.499,134720.852,448666.332,134722.505,448666.099,134722.541,448666.37,134723.172,448668.398,134725.377,448667.707,134728.922,448667.322,134731.217,448667.625,134731.535,448665.325,134735.665,448659.473,134737.321,448660.608,134787.547,448694.701,134786.952,448696.342,134786.174,448698.759,134785.64,448701.244))

3.802,134699.023,448682.417,134696.538,448681.075,134697.913,448678.885,134699.428,448676.8,134700.565,448675.391,134700.712,448675.208,134700.765,448675.251,134702.313,448673.698,134703.377,448672.629,134706.297,448670.345,134709.512,448668.514,134709.497,448668.455,134710.251,448668.131,134714.149,448667.027,134714.93,448666.866,134717.197,448666.642,134718.644,448666.499,134720.852,448666.332,134722.505,448666.099,134722.541,448666.37,134723.172,448668.398,134725.377,448667.707,134728.922,448667.322,134731.217,448667.625,134731.535,448665.325,134735.665,448659.473,134737.321,448660.608,134787.547,448694.701,134786.952,448696.342,134786.174,448698.759,134785.64,448701.244))

00.712,448675.208,134700.765,448675.251,134702.313,448673.698,134703.377,448672.629,134706.297,448670.345,134709.512,448668.514,134709.497,448668.455,134710.251,448668.131,134714.149,448667.027,134714.93,448666.866,134717.197,448666.642,134718.644,448666.499,134720.852,448666.332,134722.505,448666.099,134722.541,448666.37,134723.172,448668.398,134725.377,448667.707,134728.922,448667.322,134731.217,448667.625,134731.535,448665.325,134735.665,448659.473,134737.321,448660.608,134787.547,448694.701,134786.952,448696.342,134786.174,448698.759,134785.64,448701.244))
48668.514,134709.497,448668.455,134710.251,448668.131,134714.149,448667.027,134714.93,448666.866,134717.197,448666.642,134718.644,448666.499,134720.852,448666.332,134722.505,448666.099,134722.541,448666.37,134723.172,448668.398,134725.377,448667.707,134728.922,448667.322,134731.217,448667.625,134731.535,448665.325,134735.665,448659.473,134737.321,448660.608,134787.547,448694.701,134786.952,448696.342,134786.174,448698.759,134785.64,448701.244))

2,134718.644,448666.499,134720.852,448666.332,134722.505,448666.099,134722.541,448666.37,134723.172,448668.398,134725.377,448667.707,134728.922,448667.322,134731.217,448667.625,134731.535,448665.325,134735.665,448659.473,134737.321,448660.608,134787.547,448694.701,134786.952,448696.342,134786.174,448698.759,134785.64,448701.244))

.377,448667.707,134728.922,448667.322,134731.217,448667.625,134731.535,448665.325,134735.665,448659.473,134737.321,448660.608,134787.547,448694.701,134786.952,448696.342,134786.174,448698.759,134785.64,448701.244))

660.608,134787.547,448694.701,134786.952,448696.342,134786.174,448698.759,134785.64,448701.244))

Associated revisions

Revision 92a80894 - 2018-04-23 11:10 PM - Nyall Dawson

[oracle] Add read-only support for curved geometry types

Previously these geometries were silently discarded

Fixes #12675, #16809

Sponsored by Open Spatial (http://www.openspatial.com)

History

#1 - 2017-09-08 01:35 PM - Jürgen Fischer

- Assignee deleted (Jürgen Fischer)

#2 - 2018-04-23 11:10 PM - Nyall Dawson

- % Done changed from 0 to 100

- Status changed from Open to Closed

Applied in changeset commit:qgis|92a80894ac5e79e023b7be502afd2b84fec44483.

#3 - 2018-05-17 11:41 AM - Richard Duivenvoorde

YES! Tested, works. Thanks!
